#pragma once
#include <SFML/Graphics.hpp>

namespace config {
// Общее:
    const unsigned int FRAME_RATE_LIMIT = 60;
    enum Direction { INVALID = -1, LEFT, RIGHT, UP, DOWN };
// Меню:
    const sf::Vector2f BUTTON_SIZE = { 250, 100 };
    const size_t BUTTON_FONT_SIZE_BASE = static_cast<size_t>(BUTTON_SIZE.y / 1.5f);
    const size_t BUTTON_FONT_SIZE_VARIANT_1 = static_cast<size_t>(BUTTON_SIZE.y / 1.80f);
    const size_t BUTTON_FONT_SIZE_VARIANT_2 = static_cast<size_t>(BUTTON_SIZE.y / 2.2f);
    const size_t BUTTON_FONT_SIZE = static_cast<size_t>(BUTTON_SIZE.y / 2.1f);
    const float BUTTON_FRAME_THICKNESS = 2.0f;
    const char FONT_FILE_BASE[] = "Calibri-Light.ttf";
    const char FONT_FILE_VARIANT_1[] = "android2.ttf";
    const char FONT_FILE_VARIANT_2[] = "Oxygene1_RUS_by_KanycTa.ttf";
    const char FONT_FILE[] = "Font Over.otf";
    const char PACMAN_TEXTURE_FILE[] = "PacmanTexture.png";
    const char ENEMY_TEXTURE_FILE[] = "EnemyTexture.png";
    const char FOOD_TEXTURE_FILE[] = "FoodTexture.png";
    const char SELECT_LEVEL_TITLE[] = "Select Level";
    const sf::VideoMode SELECT_LEVEL_VIDEO_MODE{ 400, 600 };
    const char BUTTON_TEXT_EASY[] = "Easy";
    const char BUTTON_TEXT_MEDIUM[] = "Medium";
    const char BUTTON_TEXT_HARD[] = "Hard";
    const char BUTTON_TEXT_BONUS[] = "Bonus";
    const char BUTTON_TEXT_EXIT[] = "Exit";
// Игра:
    const sf::VideoMode GAME_VIDEO_MODE{ 1080, 720 };
    const char EASY_GAME_TITLE[] = "Level: Easy";
    const char MEDIUM_GAME_TITLE[] = "Level: Medium";
    const char HARD_GAME_TITLE[] = "Level: Hard";
    const char BONUS_GAME_TITLE[] = "Level: Bonus";
    const float EASY_GAME_ENEMY_RATIO = 0.0f;
    const float MEDIUM_GAME_ENEMY_RATIO = 0.03f;
    const float HARD_GAME_ENEMY_RATIO = 0.05f;
    const float ROOM_SIZE_EASY = 140;
    const float ROOM_SIZE_MEADIUM = 50;
    const float ROOM_SIZE = 50;
    const float GAME_ENEMY_SIZE = ROOM_SIZE * 0.7;
    const float GAME_FOOD_SIZE = ROOM_SIZE * 0.2;
// Пакмэн:
    const float GAME_PACMAN_SIZE = ROOM_SIZE * 0.8;
    const sf::Keyboard::Key KEY_LEFT = sf::Keyboard::A;
    const sf::Keyboard::Key KEY_RIGHT = sf::Keyboard::D;
    const sf::Keyboard::Key KEY_UP = sf::Keyboard::W;
    const sf::Keyboard::Key KEY_DOWN = sf::Keyboard::S;
// Цвета:
    const sf::Color BUTTON_COLOR_TEXT_BASE{ 0, 0, 0 };
    const sf::Color BUTTON_COLOR_TEXT{ 37, 35, 35 };
    const sf::Color BUTTON_COLOR_FILL_BASE{ 180, 180, 180 };
    const sf::Color BUTTON_COLOR_FILL{ 181,111,217 };
    const sf::Color BUTTON_COLOR_SELECTION_BASE{ 255, 180, 180 };
    const sf::Color BUTTON_COLOR_SELECTION{ 202,151,238 };
    const sf::Color BUTTON_COLOR_FRAME_BASE{ 0, 0, 0 };
    const sf::Color BUTTON_COLOR_FRAME{ 250, 166, 38 };
    const sf::Color SELECT_LEVEL_BACKGROUND_COLOR_BASE{ 230,230,230 };
    const sf::Color SELECT_LEVEL_BACKGROUND_COLOR{ 84,147,255 };
    const sf::Color GAME_COLOR_BACKGROUND_INGAME_BASE{ 230,230,230 };
    const sf::Color GAME_COLOR_BACKGROUND_INGAME{ 84,147,255 };
    const sf::Color GAME_COLOR_BACKGROUND_WIN{ 0, 255, 0 };
    const sf::Color GAME_COLOR_BACKGROUND_LOST{ 255, 0, 0 };
    const sf::Color GAME_COLOR_PACMAN_BASE{ 250, 150, 0 };
    const sf::Color GAME_COLOR_PACMAN{ 250, 150, 0 };
    const sf::Color GAME_COLOR_ROOM_BASE{ 255, 255, 255 };
    const sf::Color GAME_COLOR_ROOM{ 230, 239, 233 };
    const sf::Color GAME_COLOR_WALL_BASE{ 0, 0, 0 };
    const sf::Color GAME_COLOR_WALL{ 250, 166, 38 };
    const sf::Color GAME_COLOR_TELEPORT{ 95, 22, 156 };
    const sf::Color GAME_FOOD_COLOR_BASE{ 0, 200, 100 };
    const sf::Color GAME_FOOD_COLOR{ 83, 200, 108 };
    const sf::Color GAME_ENEMY_COLOR_BASE{ 255, 50, 0 };
    const sf::Color GAME_ENEMY_COLOR{ 255, 62, 65 };
}