#include "MazeContent/Buildings/Teleport.h"
#include "MazeContent/Entities/IEntity.h"
#include "Config.h"

#include "iostream"

Teleport::Teleport(Room& room1, Room& room2, Room& room3, Room& room4,
                   Room& room5, Room& room6, Room& room7,Room& room8) {
    m_rooms.emplace_back(std::ref(room1));
    m_rooms.emplace_back(std::ref(room2));
    m_rooms.emplace_back(std::ref(room3));
    m_rooms.emplace_back(std::ref(room4));
    m_rooms.emplace_back(std::ref(room5));
    m_rooms.emplace_back(std::ref(room6));
    m_rooms.emplace_back(std::ref(room7));
    m_rooms.emplace_back(std::ref(room8));
}

//void Teleport::prepare_for_drawing()  {
//    for (size_t i = 0; i < m_rooms.size(); ++i) {
//        sf::Vector2f pos = m_rooms.at(i).get().get_position();
//        switch (m_rooms.at(i).get().get_direction(this)) {
//            case Room::LEFT:
//                lines.emplace_back(std::array<sf::Vertex, 2>{
//                        sf::Vertex{sf::Vector2f(pos.x - m_rooms.at(i).get().get_size() / 2,
//                                                pos.y - m_rooms.at(i).get().get_size() / 2), config::GAME_COLOR_TELEPORT},
//                        sf::Vertex{sf::Vector2f(pos.x - m_rooms.at(i).get().get_size() / 2,
//                                                pos.y + m_rooms.at(i).get().get_size() / 2), config::GAME_COLOR_TELEPORT}
//                });
//                break;
//
//            case Room::RIGHT:
//                lines.emplace_back(std::array<sf::Vertex, 2>{
//                        sf::Vertex{sf::Vector2f(pos.x + m_rooms.at(i).get().get_size() / 2,
//                                                pos.y - m_rooms.at(i).get().get_size() / 2), config::GAME_COLOR_TELEPORT},
//                        sf::Vertex{sf::Vector2f(pos.x + m_rooms.at(i).get().get_size() / 2,
//                                                pos.y + m_rooms.at(i).get().get_size() / 2), config::GAME_COLOR_TELEPORT}
//                });
//                break;
//
//            case Room::UP:
//                lines.emplace_back(std::array<sf::Vertex, 2>{
//                        sf::Vertex{sf::Vector2f(pos.x - m_rooms.at(i).get().get_size() / 2,
//                                                pos.y - m_rooms.at(i).get().get_size() / 2), config::GAME_COLOR_TELEPORT},
//                        sf::Vertex{sf::Vector2f(pos.x + m_rooms.at(i).get().get_size() / 2,
//                                                pos.y - m_rooms.at(i).get().get_size() / 2), config::GAME_COLOR_TELEPORT}
//                });
//                break;
//
//            case Room::DOWN:
//                lines.emplace_back(std::array<sf::Vertex, 2>{
//                        sf::Vertex{sf::Vector2f(pos.x - m_rooms.at(i).get().get_size() / 2,
//                                                pos.y + m_rooms.at(i).get().get_size() / 2), config::GAME_COLOR_TELEPORT},
//                        sf::Vertex{sf::Vector2f(pos.x + m_rooms.at(i).get().get_size() / 2,
//                                                pos.y + m_rooms.at(i).get().get_size() / 2), config::GAME_COLOR_TELEPORT}
//                });
//                break;
//
//            default:
//                throw std::runtime_error("Invalid side in the room!");
//        }
//    }
//}

void Teleport::enter(IEntity* entity) {
    size_t number = m_rooms.size();
    for (size_t i = 0; i < number; ++i) {
        if (entity->get_location() == &(m_rooms.at(i).get()))
            entity->set_location(&(m_rooms.at(rand() % number).get()));
    }
}

//void Teleport::draw_into(sf::RenderWindow& window) const {
//    for (const auto& line : lines)
//        window.draw(line.data(), 2, sf::Lines);
//}

void Teleport::prepare_for_drawing() {
    rectangles.clear(); // Очищаем предыдущие фигуры

    for (size_t i = 0; i < m_rooms.size(); ++i) {
        sf::Vector2f pos = m_rooms.at(i).get().get_position();
        float room_size = m_rooms.at(i).get().get_size();
        sf::Color color = config::GAME_COLOR_TELEPORT;

        sf::RectangleShape rect;
        rect.setFillColor(color);

        switch (m_rooms.at(i).get().get_direction(this)) {
            case Room::LEFT:
                rect.setSize({line_thickness, room_size});
                rect.setPosition(pos.x - room_size/2 - line_thickness/2, pos.y - room_size/2);
                break;

            case Room::RIGHT:
                rect.setSize({line_thickness, room_size});
                rect.setPosition(pos.x + room_size/2 - line_thickness/2, pos.y - room_size/2);
                break;

            case Room::UP:
                rect.setSize({room_size, line_thickness});
                rect.setPosition(pos.x - room_size/2, pos.y - room_size/2 - line_thickness/2);
                break;

            case Room::DOWN:
                rect.setSize({room_size, line_thickness});
                rect.setPosition(pos.x - room_size/2, pos.y + room_size/2 - line_thickness/2);
                break;

            default:
                throw std::runtime_error("Invalid side in the room!");
        }
        rectangles.push_back(rect);
    }
}

void Teleport::draw_into(sf::RenderWindow& window) const {
    for (const auto& rect : rectangles) {
        window.draw(rect);
    }
}